//-------------------------------------------------------------
// File: main.h
//
// Desc: PR
//-------------------------------------------------------------
#pragma once

#define REDUCTION_MAPS 2

//-------------------------------------------------------------
// `萔
//-------------------------------------------------------------
// ݂̓̓f[^ۑ\
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
    BOOL bChangeShader;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: AvP[ṼNX
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	int						m_iState;		// ԕϐ
	int						m_iChangeState;	// ԕϐ
	int						m_iCount;		// ԕϐǗpԕϐ

	int						m_Shader;

	CD3DMesh				*m_pMeshBg;
			
	// VF[_
	LPD3DXEFFECT		    m_pEffect;		// GtFNg
	D3DXHANDLE				m_hTechnique;	// eNjbN
	D3DXHANDLE				m_hmWVP;		// ϊs
	D3DXHANDLE				m_htSrcTex;		// eNX`

	// _O^[Qbg
	LPDIRECT3DSURFACE9		m_pMapZ;		// [xobt@
	LPDIRECT3DTEXTURE9		m_pPosTex;	// }bv
	LPDIRECT3DSURFACE9		m_pPosSurf;	// 
	LPDIRECT3DTEXTURE9		m_pPosLockTex;	// 
	LPDIRECT3DSURFACE9		m_pPosLockSurf;	// 
	LPDIRECT3DTEXTURE9		m_pNormalTex;	// @}bv
	LPDIRECT3DSURFACE9		m_pNormalSurf;	// 
	LPDIRECT3DTEXTURE9		m_pNormalLockTex;	// 
	LPDIRECT3DSURFACE9		m_pNormalLockSurf;	// 
	LPDIRECT3DTEXTURE9		m_pDiffuseTex;		// gU}bv
	LPDIRECT3DSURFACE9		m_pDiffuseSurf;		// gU}bv
	LPDIRECT3DTEXTURE9		m_pFinalTex;
	LPDIRECT3DSURFACE9		m_pFinalSurf;
	LPDIRECT3DTEXTURE9		m_pReductionTex [REDUCTION_MAPS];		// kobt@
	LPDIRECT3DSURFACE9		m_pReductionSurf[REDUCTION_MAPS];		// kobt@
	LPDIRECT3DTEXTURE9		m_pMaskTex;			// WvZ


	// ʏ̍Wϊs
	D3DXMATRIX				m_mWorld;
	D3DXMATRIX				m_mView;
	D3DXMATRIX				m_mProj;

	D3DXVECTOR3				m_LighPos;		// ̕

	BOOL					m_bLoadingApp;	// [hH
    CD3DFont*				m_pFont;		// tHg
    UserInput				m_UserInput;	// ̓f[^

    FLOAT                   m_fWorldRotX;   // w]
    FLOAT                   m_fWorldRotY;   // x]
    FLOAT                   m_fViewZoom;    // _̋

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

    // ʒuA@}bv
    virtual int FrameMoveCreateMap();
	virtual void RenderCreateMap();
    // gǓvZ
    virtual int FrameMoveFinalGathering();
	virtual void RenderFinalGathering();

	HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

